package com.steerinfo.meterwork.meterworknotice.controller;

import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.meterwork.meterworkcaractual.mapper.MeterWorkCarActualMapper;
import com.steerinfo.meterwork.meterworknotice.mapper.MeterWorkNoticeMapper;
import com.steerinfo.meterwork.meterworknotice.model.MeterWorkNotice;
import com.steerinfo.meterwork.meterworknotice.service.IMeterWorkNoticeService;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.lang3.StringUtils;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.text.SimpleDateFormat;
import java.util.*;
import java.math.BigDecimal;

/**
 * MeterWorkNotice RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2022-01-22 09:53
 * 类描述
 * 修订历史：
 * 日期：2022-01-22
 * 作者：generator
 * 参考：
 * 描述：MeterWorkNotice RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/meterworknotices")
public class MeterWorkNoticeController extends BaseRESTfulController {

    @Autowired
    IMeterWorkNoticeService meterWorkNoticeService;
    MeterWorkNoticeMapper meterWorkNoticeMapper;

    @ApiOperation(value="获取列表", notes="分页查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworknotice:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterWorkNotice> list = meterWorkNoticeService.queryForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworknotice:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterWorkNotice> list = meterWorkNoticeService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }
    
    @ApiOperation(value="创建", notes="根据MeterWorkNotice对象创建")
    @ApiImplicitParam(name = "meterWorkNotice", value = "详细实体meterWorkNotice", required = true, dataType = "MeterWorkNotice")
    //@RequiresPermissions("meterworknotice:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@RequestBody MeterWorkNotice model){
        if (model == null) {
            return failed("参数为空");
        }
        SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMdd");
        model.setPublishTime(new Date());
        model.setValidFlag("0");
        MeterWorkNotice meterWorkNotice = meterWorkNoticeService.add(model);
        return success(meterWorkNotice);
    }

    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterworknotice:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id){
        MeterWorkNotice meterWorkNotice = meterWorkNoticeService.getById(id);
        return success(meterWorkNotice);
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的meterWorkNotice信息来更新详细信息")
    @ApiImplicitParams({
        @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
        @ApiImplicitParam(name = "meterWorkNotice", value = "详细实体meterWorkNotice", required = true, dataType = "MeterWorkNotice")
    })
    //@RequiresPermissions("meterworknotice:update")
    @PutMapping(value = "/{id}", produces  = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterWorkNotice model){
        model.setId(id);
        MeterWorkNotice meterWorkNotice = meterWorkNoticeService.modify(model);
        return success(meterWorkNotice);
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterworknotice:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id){
    	List<String> list = Arrays.asList(id.split(","));
    	if(ListUtils.isNotEmpty(list)) {
	    	List<String> ids = ListUtils.convertList(list);
			  meterWorkNoticeService.delete(ids);
    	}
      return success();
    }
}
